org.apache.ignite.internal.processors.cache.verify

## Class RetrieveConflictPartitionValuesTask

- java.lang.Object
- - org.apache.ignite.compute.ComputeTaskAdapter<Map<PartitionHashRecord,List<PartitionEntryHashRecord>>,Map<PartitionHashRecord,List<PartitionEntryHashRecord>>>
  - - org.apache.ignite.internal.processors.cache.verify.RetrieveConflictPartitionValuesTask

All Implemented Interfaces:
  Serializable, ComputeTask<Map<PartitionHashRecord,List<PartitionEntryHashRecord>>,Map<PartitionHashRecord,List<PartitionEntryHashRecord>>>

    @GridInternal
    public class RetrieveConflictPartitionValuesTask
    extends ComputeTaskAdapter<Map<PartitionHashRecord,List<PartitionEntryHashRecord>>,Map<PartitionHashRecord,List<PartitionEntryHashRecord>>>

See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`static class` `RetrieveConflictPartitionValuesTask.RetrieveConflictValuesJob`

### Constructor Summary

Constructors
Constructor and Description
`RetrieveConflictPartitionValuesTask()`

### Method Summary

All Methods Instance Methods Concrete Methods
`@NotNull Map<? extends ComputeJob,ClusterNode>` `map(List<ClusterNode> subgrid, Map<PartitionHashRecord,List<PartitionEntryHashRecord>> collectTaskRes)` This method is called to map or split grid task into multiple grid jobs.
`@Nullable Map<PartitionHashRecord,List<PartitionEntryHashRecord>>` `reduce(List<ComputeJobResult> results)` Reduces (or aggregates) results received so far into one compound result to be returned to caller via `ComputeTaskFuture.get()` method.
`ComputeJobResultPolicy` `result(ComputeJobResult res, List<ComputeJobResult> rcvd)` Default implementation which will wait for all jobs to complete before calling `ComputeTask.reduce(List)` method.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### RetrieveConflictPartitionValuesTask

    public RetrieveConflictPartitionValuesTask()

### Method Detail

#### map

    @NotNull
    public @NotNull Map<? extends ComputeJob,ClusterNode> map(List<ClusterNode> subgrid,
                                                                       Map<PartitionHashRecord,List<PartitionEntryHashRecord>> collectTaskRes)
                                                                throws IgniteException

This method is called to map or split grid task into multiple grid jobs. This is the first method that gets called when task execution starts.

Parameters:
  `subgrid` - Nodes available for this task execution. Note that order of nodes is guaranteed to be randomized by container. This ensures that every time you simply iterate through grid nodes, the order of nodes will be random which over time should result into all nodes being used equally.
  `collectTaskRes` - Task execution argument. Can be `null`. This is the same argument as the one passed into `Grid#execute(...)` methods.
Returns:
  Map of grid jobs assigned to subgrid node. Unless `ComputeTaskContinuousMapper` is injected into task, if `null` or empty map is returned, exception will be thrown.
Throws:
  `IgniteException` - If mapping could not complete successfully. This exception will be thrown out of `ComputeTaskFuture.get()` method.

#### reduce

    @Nullable
    public @Nullable Map<PartitionHashRecord,List<PartitionEntryHashRecord>> reduce(List<ComputeJobResult> results)
                                                                                       throws IgniteException

Reduces (or aggregates) results received so far into one compound result to be returned to caller via `ComputeTaskFuture.get()` method.

Note, that if some jobs did not succeed and could not be failed over then the list of results passed into this method will include the failed results. Otherwise, failed results will not be in the list.

Parameters:
  `results` - Received results of broadcasted remote executions. Note that if task class has `ComputeTaskNoResultCache` annotation, then this list will be empty.
Returns:
  Grid job result constructed from results of remote executions.
Throws:
  `IgniteException` - If reduction or results caused an error. This exception will be thrown out of `ComputeTaskFuture.get()` method.

#### result

    public ComputeJobResultPolicy result(ComputeJobResult res,
                                         List<ComputeJobResult> rcvd)

Default implementation which will wait for all jobs to complete before calling `ComputeTask.reduce(List)` method.

If remote job resulted in exception (`ComputeJobResult.getException()` is not `null`), then `ComputeJobResultPolicy.FAILOVER` policy will be returned if the exception is instance of `ClusterTopologyException` or `ComputeExecutionRejectedException`, which means that remote node either failed or job execution was rejected before it got a chance to start. In all other cases the exception will be rethrown which will ultimately cause task to fail.

Specified by:
  `result` in interface `ComputeTask<Map<PartitionHashRecord,List<PartitionEntryHashRecord>>,Map<PartitionHashRecord,List<PartitionEntryHashRecord>>>`
Overrides:
  `result` in class `ComputeTaskAdapter<Map<PartitionHashRecord,List<PartitionEntryHashRecord>>,Map<PartitionHashRecord,List<PartitionEntryHashRecord>>>`
Parameters:
  `res` - Received remote grid executable result.
  `rcvd` - All previously received results.
Returns:
  Result policy that dictates how to process further upcoming job results.

${current.year} Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Database and Caching Platform | : ver. 2.8.1
Release Date | : May 21 2020